.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

Algo MACRO arg
	invoke Sleep, SleepMs
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	REPEAT 64
			invoke &arg, 12345678, 55
		ENDM
	counter_end
	shr eax, 6
	print str$(eax), 9, "cycles for &arg", 13, 10
ENDM

CodeSize MACRO algo	; macro modified from MasmBasic
  mov eax, offset &algo&_e
  sub eax, offset &algo&_s
  print str$(eax), 9, "bytes for &algo&, result="
  invoke &algo, 12345678, 55	; expected 6790122.9
  print str$(eax), 13, 10
ENDM

.code

GetPercent_s:
GetPercent proc source:DWORD, percent:DWORD	; the original from m32\getpcnt.asm

    LOCAL var1:DWORD

    mov var1, 100   ; to divide by 100

    fild source     ; load source integer
    fild var1       ; load 100
    fdiv            ; divide source by 100
    fild percent    ; load required percentage
    fmul            ; multiply 1% by required percentage
    fistp var1      ; store result in variable
    mov eax, var1
    ret
GetPercent endp
GetPercent_e:

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
GetPercentJJ1_s:
GPJ001	REAL10 0.01
GetPercentJJ1 proc source:DWORD, percent:DWORD
;		ffree st(7)
		push eax
	fld GPJ001	; mul source by 0.01, i.e. divide by 100
	fimul dword ptr [esp+8]	; load source integer
	fimul dword ptr [esp+12]	; multiply 1% by required percentage
	fistp dword ptr [esp]	; store result on stack
	pop eax	; return in eax
	ret 8
GetPercentJJ1 endp
GetPercentJJ1_e:

GetPercentJJ2_s:
GPJ002	REAL8 0.01
GetPercentJJ2 proc source:DWORD, percent:DWORD
		ffree st(7)
		push eax
	fild dword ptr [esp+8]	; load source integer
	fmul GPJ002	; multiply with 0.01, i.e. divide source by 100
	fimul dword ptr [esp+12]	; multiply 1% by required percentage
	fistp dword ptr [esp]	; store result on stack
	pop eax	; return in eax
	ret 8
GetPercentJJ2 endp
GetPercentJJ2_e:

GetPercentJJ3_s:
GetPercentJJ3 proc source:DWORD, percent:DWORD
		mov eax, [esp+4]	; source
		imul dword ptr [esp+8]	; percent
		push 100
		idiv dword ptr [esp]
		pop edx
		ret 8
GetPercentJJ3 endp
GetPercentJJ3_e:

GetPercentJJ4_s:
GPJ004	REAL8 0.01
GetPercentJJ4 proc source:DWORD, percent:DWORD
		mov eax, [esp+4]	; source
		imul dword ptr [esp+8]	; percent
		push eax
	fild dword ptr [esp]	; load source integer
	fmul GPJ004	; divide source by 100
	fistp dword ptr [esp]	; store result on stack
	pop eax	; return in eax
		ret 8
GetPercentJJ4 endp
GetPercentJJ4_e:

GetPercentSSE_s:
GPJ005	REAL8 0.01
GetPercentSSE proc source:DWORD, percent:DWORD
	cvtsi2sd xmm0, dword ptr [esp+4]		; source
	cvtsi2sd xmm1, dword ptr [esp+8]		; percent
	mulsd xmm0, xmm1
	mulsd xmm0, GPJ005		; multiply with 0.01, i.e. divide source by 100
	cvtsd2si eax, xmm0
	ret 8		; 11 cycles
GetPercentSSE endp
GetPercentSSE_e:

GetPercentSSEs_s:
GPJ005s	REAL8 0.01
GetPercentSSEs proc source:DWORD, percent:DWORD
;	xorps xmm0, xmm0
;	movaps xmm1, xmm0	; no effect
	movd xmm0, dword ptr [esp+4]	; source
	movd xmm1, dword ptr [esp+8]	; percent
;	int 3	; OPT_Olly 2
	pmuludq xmm0, xmm1			; source * percent, OK (pm xmm0, qword ptr [esp+8] possible but slow)
	MakeSlow = 1
	if MakeSlow						; first branch: result is correct but >200 cycles
		mulsd xmm0, GPJ005s		; multiply with 0.01, i.e. divide source by 100 - SLOOOOOOW ###
		movd eax, xmm0
	else							; second branch: result correct, 27 cycles
		cvtdq2pd xmm0, xmm0		; convert integer to float (Convert  Packed Doubleword Integers to Packed Double-Precision Floating-Point Values)
		mulsd xmm0, GPJ005s		; multiply with 0.01, i.e. divide source by 100 - fast
		cvtsd2si eax, xmm0
	endif
	ret 8		; 259 or 348 cycles
GetPercentSSEs endp
GetPercentSSEs_e:

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
start:	push 1
	call ShowCpu	; print brand string and SSE level

;		invoke GetPercentSSE, 222222222, 50
;		print str$(eax), " - should be 111111111", 13, 10

	SleepMs =	50	; test if anything changes when changing this
	LOOP_COUNT =	100000	; One Mio would be a typical value
	REPEAT 1
		Algo GetPercent
;		Algo GetPercentJJ1
		Algo GetPercentJJ2
;		Algo GetPercentJJ3
;		Algo GetPercentJJ4
		Algo GetPercentSSE
		Algo GetPercentSSEs	; slow version
		print chr$(13, 10)
	ENDM
	if 1
	print "Code sizes:", 13, 10
	CodeSize GetPercent
;	CodeSize GetPercentJJ1
	CodeSize GetPercentJJ2
;	CodeSize GetPercentJJ3
;	CodeSize GetPercentJJ4
	CodeSize GetPercentSSE
	CodeSize GetPercentSSEs
	endif
	inkey chr$(13, 10, "--- ok ---", 13)
	exit

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]